#include "cdialog_main.h"

//-   ----------------------------------------
BEGIN_MESSAGE_MAP(CDialog_Main,CDialog)
 ON_WM_DESTROY()
 ON_WM_CLOSE()
 ON_WM_PAINT()
 ON_WM_TIMER()
END_MESSAGE_MAP()
//- --------------------------------------------------------
CDialog_Main::CDialog_Main(LPCTSTR lpszTemplateName, CWnd* pParentWnd):CDialog(lpszTemplateName,pParentWnd)
{
 ImagePtr=new unsigned long[IMAGE_WIDTH*IMAGE_HEIGHT];
 for(long n=0;n<IMAGE_WIDTH*IMAGE_HEIGHT;n++) ImagePtr[n]=255;
 cWinThread_ProcessingThread=NULL;
}
//- ---------------------------------------------------------
CDialog_Main::~CDialog_Main()
{
 delete[](ImagePtr);
}
//-  -------------------------------------------------
afx_msg void CDialog_Main::OnOK(void)
{
}
afx_msg void CDialog_Main::OnCancel(void)
{
}
afx_msg void CDialog_Main::OnClose(void)
{
 EndDialog(0);
}
afx_msg BOOL CDialog_Main::OnInitDialog(void)
{
 StartThread();
 // 
 SetTimer(ID_TIMER_UPDATE,100,NULL);
 return(CDialog::OnInitDialog());
}
//-  ------------------------------------------------------
//-   ----------------------------------------
afx_msg void CDialog_Main::OnDestroy(void)
{
 KillTimer(ID_TIMER_UPDATE);
 StopThread();
 CDialog::OnDestroy();
}
afx_msg void CDialog_Main::OnTimer(UINT nIDEvent)
{
 if (nIDEvent==ID_TIMER_UPDATE) InvalidateRect(NULL,FALSE);
 CDialog::OnTimer(nIDEvent);
}
afx_msg void CDialog_Main::OnPaint(void)
{
 CDialog::OnPaint();
 CPaintDC cPaintDC(((CStatic *)GetDlgItem(IDC_STATIC_MAIN)));

 CRect cRect;
 ((CStatic *)GetDlgItem(IDC_STATIC_MAIN))->GetClientRect(&cRect);
 
 BITMAPINFOHEADER bmih;
 bmih.biSize=sizeof(BITMAPINFOHEADER);
 bmih.biWidth=IMAGE_WIDTH;
 bmih.biHeight=IMAGE_HEIGHT;
 bmih.biPlanes=1;
 bmih.biBitCount=32;
 bmih.biCompression=BI_RGB;
 bmih.biSizeImage=0;
 bmih.biXPelsPerMeter=300;
 bmih.biYPelsPerMeter=300;
 bmih.biClrUsed=0;
 bmih.biClrImportant=0;
 RGBQUAD rgbq;
 BITMAPINFO info;
 rgbq.rgbBlue=1;
 rgbq.rgbGreen=0;
 rgbq.rgbRed=0;
 rgbq.rgbReserved=0;
 info.bmiHeader=bmih;
 info.bmiColors[0]=rgbq;

 StretchDIBits(cPaintDC,cRect.left,cRect.top,cRect.right-cRect.left,cRect.bottom-cRect.top,0,0,abs(bmih.biWidth),abs(bmih.biHeight),ImagePtr,&info,DIB_RGB_COLORS,SRCCOPY);
}
//---------------------------------------------------------------------------
// 
//---------------------------------------------------------------------------
void CDialog_Main::StartThread(void)
{
 StopThread();
 //  
 cEvent_Exit.ResetEvent();
 cWinThread_ProcessingThread=AfxBeginThread((AFX_THREADPROC)ProcessingThread,this);
 cWinThread_ProcessingThread->m_bAutoDelete=FALSE;
 SetThreadPriority(cWinThread_ProcessingThread->m_hThread,THREAD_PRIORITY_TIME_CRITICAL);
}
//---------------------------------------------------------------------------
// 
//---------------------------------------------------------------------------
void CDialog_Main::StopThread(void)
{
 //  
 if (cWinThread_ProcessingThread!=NULL)
 {
  cEvent_Exit.SetEvent();
  if (cWinThread_ProcessingThread->m_hThread) WaitForSingleObject(cWinThread_ProcessingThread->m_hThread,INFINITE);
  delete(cWinThread_ProcessingThread);
 }
 cWinThread_ProcessingThread=NULL;
}
//---------------------------------------------------------------------------
//     
//---------------------------------------------------------------------------
CEvent* CDialog_Main::GetEventExitPtr(void)
{
 return(&cEvent_Exit);
}
//-  ------------------------------------------------------



//---------------------------------------------------------------------------
// 
//---------------------------------------------------------------------------
UINT ProcessingThread(LPVOID pParam)
{
 unsigned long delay=0;
 timeBeginPeriod(1);
 CFlirOneControl cFlirOneControl;//   Flir One Get 2 
 CDialog_Main *cDialog_Main_Ptr=reinterpret_cast<CDialog_Main *>(pParam);
 CEvent *cEvent_Exit_Ptr=cDialog_Main_Ptr->GetEventExitPtr();
 while(1)
 {
  if (WaitForSingleObject(cEvent_Exit_Ptr->m_hObject,delay)==WAIT_OBJECT_0) break;// 1    
  delay=0;
  if (cFlirOneControl.Processing()==false)
  {
   cFlirOneControl.Open();
   delay=1000;
  }
 }
 timeEndPeriod(1);
 return(0);
}


