#include "cflironecontrol.h"

//- --------------------------------------------------------
CFlirOneControl::CFlirOneControl(void)
{
 USBDeviceHandle=NULL;
 SizeOfData=1048576;
 Data=new char[SizeOfData]; 
}
//- ---------------------------------------------------------
CFlirOneControl::~CFlirOneControl()
{
 delete[](Data);
 Close();
}
//- ------------------------------------------------------------

//----------------------------------------------------------------------------------------------------
//  
//----------------------------------------------------------------------------------------------------
bool CFlirOneControl::Open(void)
{
 Close();
 
 usb_init();
 usb_find_busses();
 usb_find_devices();
 // Flir One Gen 2
 struct usb_bus *bus;
 struct usb_device *dev; 
 USBDeviceHandle=NULL;
 for (bus=usb_get_busses();bus!=NULL;bus=bus->next)
 { 
  for (dev=bus->devices;dev!=NULL;dev=dev->next)
  {
   if (dev->descriptor.idVendor==VENDOR_ID && dev->descriptor.idProduct==PRODUCT_ID)
   {
    USBDeviceHandle=usb_open(dev);
	if (USBDeviceHandle!=NULL) break;//    
   }
  }
  if (USBDeviceHandle!=NULL) break;
 }
 if (USBDeviceHandle==NULL)
 {
  Close();
  AddLog("[]  Flir One Gen 2  !\r\n");
  return(false);
 }
 //  
 if (usb_set_configuration(USBDeviceHandle,3)<0)
 {
  Close();
  AddLog("[]    !\r\n");
  return(false);
 }
 if (usb_claim_interface(USBDeviceHandle,0)<0)
 {
  Close();
  AddLog("[]    0!\r\n");
  return(false);
 } 
 if (usb_claim_interface(USBDeviceHandle,1)<0)
 {
  Close();
  AddLog("[]    1!\r\n");
  return(false);
 }
 if (usb_claim_interface(USBDeviceHandle,2)<0)
 {
  Close();
  AddLog("[]    2!\r\n");
  return(false);
 }
 AddLog("  .\r\n");
 Mode=1;
 return(true);
}
//----------------------------------------------------------------------------------------------------
//  
//----------------------------------------------------------------------------------------------------
void CFlirOneControl::Close(void)
{
 if (USBDeviceHandle!=NULL)
 {
  AddLog(" .\r\n");
  //usb_release_interface(USBDeviceHandle,0);
  usb_reset(USBDeviceHandle);
  usb_close(USBDeviceHandle);
 }
 USBDeviceHandle=NULL;
}
//----------------------------------------------------------------------------------------------------
//
//----------------------------------------------------------------------------------------------------
bool CFlirOneControl::Processing(void)
{
 if (USBDeviceHandle==NULL) return(false);
 char data[2]={0,0};
 unsigned long mode=Mode;
 if (mode==1)
 {  
  data[0]=0;
  data[1]=0;
  //  2 (FRAME)
  if (usb_control_msg(USBDeviceHandle,1,0x0b,0,2,data,0,100)<0)
  {
   Close();
   AddLog("[]    2!\r\n");
   return(false);// 
  }
  data[0]=0;
  data[1]=0;
  //  1 (FILEIO)
  if (usb_control_msg(USBDeviceHandle,1,0x0b,0,1,data,0,100)<0) 
  {
   Close();
   AddLog("[]    1!\r\n");
   return(false);// 
  }  
  data[0]=0;
  data[1]=0;
  //  1 (FILEIO)
  if (usb_control_msg(USBDeviceHandle,1,0x0b,1,1,data,0,100)<0)
  {
   Close();
   AddLog("[]    1!\r\n");
   return(false);// 
  }
  Mode=3;
 } 
 if (mode==2)
 {
/*

  unsigned char my_string2[16]={0xcc,0x01,0x00,0x00,0x01,0x00,0x00,0x00,0x41,0x00,0x00,0x00,0xF8,0xB3,0xF7,0x00};
  char my_string[128];
  long length=16;
  long transferred=usb_bulk_write(USBDeviceHandle,2,reinterpret_cast<char*>(my_string2),length,0);
  if (transferred!=length) 
  {
   Close();
   AddLog("[]     1!\r\n");
   return(false);
  }
  strcpy(my_string,"{\"type\":\"openFile\",\"data\":{\"mode\":\"r\",\"path\":\"CameraFiles.zip\"}}");
  length=strlen(my_string)+1;
  transferred=usb_bulk_write(USBDeviceHandle,USB_ENDPOINT_OUT|USB_RECIP_ENDPOINT,reinterpret_cast<char*>(my_string),length,0);
  if (transferred!=length) 
  {
   Close();
   AddLog("[]     2!\r\n");
   return(false);
  }
  unsigned char my_string3[16]={0xcc,0x01,0x00,0x00,0x01,0x00,0x00,0x00,0x33,0x00,0x00,0x00,0xef,0xdb,0xc1,0xc1};
  length=16;
  transferred=usb_bulk_write(USBDeviceHandle,USB_ENDPOINT_OUT|USB_RECIP_ENDPOINT,reinterpret_cast<char*>(my_string3),length,0);
  if (transferred!=length) 
  {
   Close();
   AddLog("[]     3!\r\n");
   return(false);
  }
  strcpy(my_string,"{\"type\":\"readFile\",\"data\":{\"streamIdentifier\":10}}");
  length=strlen(my_string)+1;
  transferred=usb_bulk_write(USBDeviceHandle,USB_ENDPOINT_OUT|USB_RECIP_ENDPOINT,reinterpret_cast<char*>(my_string),length,0);
  if (transferred!=length) 
  {
   Close();
   AddLog("[]     4!\r\n");
   return(false);
  }*/
  Mode=3;
 }
 if (mode==3)
 {
  //  2 (FRAME)
  data[0]=0;
  data[1]=0;
  if (usb_control_msg(USBDeviceHandle,1,0x0b,1,2,data,2,200)<0)
  {
   Close();
   AddLog("[]     frame!\r\n");
   return(false);// 
  }
  Mode=4;
 }
 if (mode==4)
 {
  long received=usb_bulk_read(USBDeviceHandle,0x85,Data,SizeOfData,100);
  if (received>0)
  {
   AddLog("  frame.\r\n");
   FILE *file=fopen("data.txt","ab");
   fwrite(Data,received,1,file);
   fclose(file);
  }
  else
  {
   AddLog("[]    frame! ");
   AddLog(usb_strerror());
  }
 }
 long received=usb_bulk_read(USBDeviceHandle,0x81,Data,SizeOfData,10);
 /*
 if (received<0)
 {
  AddLog("[]    iAP! ");
  AddLog(usb_strerror());
 }
 else AddLog("  iAP.\r\n");
 */
 received=usb_bulk_read(USBDeviceHandle,0x83,Data,SizeOfData,10);
 /*
 if (received<0)
 {
  AddLog("[]    fileio! ");
  AddLog(usb_strerror());
 }
 else AddLog("  fileio.\r\n");
 */
 if (strcmp(usb_strerror(),"LIBUSB_ERROR_NO_DEVICE")==0)
 {
  Close();
  AddLog("[]  LIBUSB_ERROR_NO_DEVICE!\r\n");
  return(false);
 }
 return(true);
}


//----------------------------------------------------------------------------------------------------
//   log-
//----------------------------------------------------------------------------------------------------
void CFlirOneControl::AddLog(char *string)
{
 FILE *file=fopen("log.txt","ab");
 if (file==NULL) return;
 fprintf(file,"%s",string);
 fclose(file);
}

//---------------------------------------------------------------------

